=== debian/changelog ===
libpmemobj-cpp (1.12-1) unstable; urgency=medium

  * Upstream release, upload to unstable.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 15 Feb 2021 13:31:08 +0100

libpmemobj-cpp (1.12~rc1-1) experimental; urgency=medium

  * New upstream RC.
  * Depend on pmdk 1.9.
  * Enable arm64 and ppc64el.
  * Disable test: cond_var_posix_0_helgrind

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 05 Feb 2021 00:02:32 +0100

libpmemobj-cpp (1.11-1) unstable; urgency=medium

  * New upstream release.
  * Enable TBB tests.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 30 Sep 2020 20:14:18 +0200

libpmemobj-cpp (1.11~rc1-1) experimental; urgency=medium

  * New upstream pre-release.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 27 Sep 2020 00:16:26 +0200

libpmemobj-cpp (1.10-3) unstable; urgency=medium

  * Paper over libunwind calling close(-1).  Closes: #967098.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 31 Aug 2020 08:51:51 +0200
