=== debian/control ===
Source: libpmemobj-cpp
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               gdb,
               graphviz,
               libncurses5-dev,
               libpmemobj-dev (>= 1.9~),
               libsfml-dev,
               libtbb-dev,
               libunwind-dev,
               pkg-config,
               valgrind
Standards-Version: 4.5.1
Rules-Requires-Root: no
Section: libs
Homepage: https://pmem.io/pmdk/cpp_obj/
Vcs-Browser: https://github.com/kilobyte/libpmemobj-cpp
Vcs-Git: https://github.com/kilobyte/libpmemobj-cpp.git -b debian

Package: libpmemobj-cpp-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
Depends: libpmemobj-dev (>= 1.9~), ${misc:Depends}, ${shlibs:Depends}
Description: C++ bindings to libpmemobj
 The C++ bindings provide an easier to use (and thus less error prone
 version) of libpmemobj -- the persistent memory object store -- through
 the implementation of a pmem-resident property, persistent pointers,
 scoped and closure transactions, locking primitives and many others.
 .
 This package contains the development headers.

Package: libpmemobj-cpp-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ bindings to libpmemobj - documentation
 The C++ bindings provide an easier to use (and thus less error prone
 version) of libpmemobj -- the persistent memory object store -- through
 the implementation of a pmem-resident property, persistent pointers,
 scoped and closure transactions, locking primitives and many others.
 .
 This package contains the documentation.
