=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_install:
	dh_auto_install -X .md5

override_dh_auto_configure:
	dh_auto_configure -- -DTESTS_USE_FORCED_PMEM=1 -DTESTS_TBB=ON

override_dh_auto_test:
	cd obj-$(DEB_HOST_GNU_TYPE) && \
		ctest -j `nproc` --force-new-ctest-process -E cond_var_posix_0_helgrind
