=== debian/changelog ===
libpmemobj-cpp (1.13.0-3) unstable; urgency=medium

  * Don't use libunwind for stack traces in the test suite, it fares poorly
    under valgrind.  Closes: #997065.
  * Enable riscv64.
  * Drop a copyright entry for rewritten check-license.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 26 Oct 2021 18:10:22 +0200

libpmemobj-cpp (1.13.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 10 Aug 2021 16:41:08 +0200

libpmemobj-cpp (1.13.0-1) experimental; urgency=medium

  * New upstream release.
  * Correct ctest exclusion syntax.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 30 Jul 2021 11:47:40 +0200

libpmemobj-cpp (1.13.0~rc2-1) experimental; urgency=medium

  * Sweep some tests on ppc64el under the carpet.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 27 Jul 2021 12:10:19 +0200

libpmemobj-cpp (1.13.0~rc1-1) experimental; urgency=medium

  * New upstream RC.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 26 Jul 2021 12:52:32 +0200
