=== debian/control ===
--- 
+++ 
@@ -10,10 +10,9 @@
                libpmemobj-dev (>= 1.9~),
                libsfml-dev,
                libtbb-dev,
-               libunwind-dev,
                pkg-config,
-               valgrind
-Standards-Version: 4.5.1
+               valgrind [!riscv64]
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://pmem.io/pmdk/cpp_obj/
@@ -22,7 +21,7 @@
 
 Package: libpmemobj-cpp-dev
 Section: libdevel
-Architecture: amd64 arm64 ppc64el
+Architecture: amd64 arm64 ppc64el riscv64
 Multi-Arch: same
 Depends: libpmemobj-dev (>= 1.9~), ${misc:Depends}, ${shlibs:Depends}
 Description: C++ bindings to libpmemobj
