=== debian/rules ===
--- 
+++ 
@@ -11,9 +11,18 @@
 override_dh_auto_install:
 	dh_auto_install -X .md5
 
+ifeq ($(DEB_HOST_ARCH),riscv64)
+CONF_ARCH := -DTESTS_USE_VALGRIND=OFF
+endif
 override_dh_auto_configure:
-	dh_auto_configure -- -DTESTS_USE_FORCED_PMEM=1 -DTESTS_TBB=ON
+	dh_auto_configure -- -DTESTS_USE_FORCED_PMEM=1 -DTESTS_TBB=ON -DUSE_LIBUNWIND=OFF $(CONF_ARCH)
+
+TEST_EXCLUDES := cond_var_posix_0_helgrind
+ifeq ($(DEB_HOST_ARCH),ppc64el)
+TEST_EXCLUDES := $(TEST_EXCLUDES)|mpsc_.*|concurrent_hash_map_layout_0_none
+endif
 
 override_dh_auto_test:
 	cd obj-$(DEB_HOST_GNU_TYPE) && \
-		ctest -j `nproc` --force-new-ctest-process -E cond_var_posix_0_helgrind
+		ctest -j `nproc` --output-on-failure --force-new-ctest-process \
+			-E '$(TEST_EXCLUDES)'
