=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*(?:-rc\d)?)\.tar\.gz%@PACKAGE@-$1.tar.gz%,uversionmangle=s/-rc/~rc/" \
   https://github.com/pmem/@PACKAGE@/tags \
   (?:.*?/)?v?(\d[\d.]*(?:-rc\d)?)\.tar\.gz debian uupdate
